/*
 *  Part of rvminis source code,
 *  Copyright (C) 2000 Alexander Kroeller (alilein@gmx.de)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
#ifndef __INSTANCE_H
#define __INSTANCE_H

#include "rvtypes.h"
#include "helpfunc.h"

typedef void(*poly_modifier)(S_RV_Poly*,rvlong*,rvlong*,S_RV_Vertex*);





class RVInstance
{
public:
  RVInstance();
  ~RVInstance();

  bool exists(void);
  void free_all(void);
  void alloc_all(void);
  
  bool load(const char *fname, FileType);
  bool save(const char *fname, FileType);

  void apply_modifier(poly_modifier);

public: 
  /* the rvmini programs are all small hacks. Why should I
   * fuddle around with data encapsulation? */
  S_RV_PRM_Mesh header;
  S_RV_Poly*    poly;
  rvlong*       ncp_type;
  rvlong*       ncp_surface;
  S_RV_Vertex*  vert;
};

#endif
