/*
 *  Part of rvminis source code,
 *  Copyright (C) 2000 Alexander Kroeller (alilein@gmx.de)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
#include <stdio.h>
#include <stdlib.h>
#include "helpfunc.h"
#include "instance.h"


rvlong new_surface;

void tmod(S_RV_Poly *p, rvlong *ncpt,rvlong *ncps, S_RV_Vertex *vlist)
{
  *ncps=new_surface;
}




int main(int argc, char **argv)
{
  RVInstance rvi;

  if(argc!=3)
    {
      printf("Usage: rvsurface  <filename>  <surface-type>\n\n");
      printf("Sets the surface type for intermediate instance files\n\n");
      return 1;
    };

  if(!filehastype(argv[1],"i-p"))
    {
      printf("Error: File must be a .i-p file\n");
      return 1;
    };

  if(!rvi.load(argv[1],Auto))
    return 1;

  sscanf(argv[2],"%d",&new_surface);

  rvi.apply_modifier(tmod);

  if(!rvi.save(argv[1],IM_PRM))
    return 1;

  printf("File '%s' modified.\n",argv[1]);

  return 0;
}
